#include <stdio.h>
#include <math.h>
// produce nfits9.pos9
// (name) (x1,y1)  (x2,y2) (x3,y3) (x4,y4) (sky) (seeing) (weight) (type)      4*weigt
//  19     9.5+9.4 ...                     8.2    5.2     7.4         2  =113 +4*7
// type=1, real cali
// type=2, calculate
// type=3, false
//
#define DIR "/line7/bg/"
#define ndate 33
int obsdate[ndate]={ 
//    150426,150507,150508,150509,150510,150511,150512
      150114,150115,150116,150117,150118,
      150208,150209,150210,150211,150212,
      150313,150314,150315,150316,150320,
      150321,150322,150323,150324,
      150412,150413,150414,150415,150417,
      150418,150419,150420,150424,150426,
      150509,150510,150513,150514
    } ;
char c1[14],c2[14],head[72][80];
double a8[8],pi,pi2,cx,cy;

char head[72][80],color;
FILE *fp,*fp1,*fp2;
int  n1,n2;
int idate,num,ccdno;
double sky,seeing,weight;
int type;

main(int ac,char **av)
{
  char a[120],f1[50],t[80];
  double x,y,alpha,delta;
  double a1,a2,a3,a4,d1,d2,d3,d4;
  int ip,i,k,ng=0;
  float ww[4];
  pi=4.*atan(1.0); cx=pi/12.; cy=pi/180.; pi2=pi/2.;
  n1=4096; n2=4032;
  if(ac<2){ printf("\n\t*** produce pos_g.dat ******\n");
            printf("\n\tpos_g !  (at any directory)\n\n");
            exit(0); }
  fp2=fopen("pos_g.dat","w");
  fprintf(fp2,"#   date/name            top_left         bottom_left");
  fprintf(fp2,"      top_right   ");
  fprintf(fp2,"      bottom_right  sky seeing weight type  A73_4_GATE\n#");
  for(i=0;i<140;i++)fprintf(fp2,"-"); fprintf(fp2,"\n");
  for(ip=0;ip<ndate;ip++){ 
    printf("%d ",obsdate[ip]); if(ip%10==9){ printf("\n"); fflush(stdout); }
    sprintf(a,"ls %s/%d/p*.fit >1.1",DIR,obsdate[ip]);
    system(a);
    fp1=fopen("1.1","r");
l10:
    fgets(a,120,fp1); if(feof(fp1))goto l20;
    strcpy(f1,a); k=strlen(f1); f1[k-1]=0;
    fp=fopen(f1,"rb");  fread(head,72,80,fp); fclose(fp);
    k=indexpos(head,"A81     ",72);
    if(k==72){ printf("fits_file not coordinated ! %s",a); goto l10; }
    for(i=0;i<8;i++)sscanf(&head[k+i][10],"%le",&a8[i]);
    k=indexpos(head,"CCD_NO: ",72);
    sscanf(&head[k][23],"%d",&ccdno);
    k=indexpos(head,"SKYADU  ",72);
    sscanf(&head[k][10],"%lf",&sky);
    k=indexpos(head,"SEEING  ",72);
    sscanf(&head[k][10],"%lf",&seeing);
    for(i=0;i<4;i++)ww[i]=0.;
    k=indexpos(head,"CALIA73 ",72);
    if(k==72){ type=-1; weight=0.; }
    else{ type=0; if(head[k][36]==32)sscanf(&head[k][65],"%d",&type);
          sscanf(&head[k][71],"%lf",&weight);
          if(head[k+1][0]!=32)for(i=0;i<4;i++)sscanf(&head[k+1+i][71],"%f",&ww[i]);}
    x=0;  y=n2;  xy_rad(a8,x,y,&a1,&d1,2,0);
    x=0;  y=0;   xy_rad(a8,x,y,&a2,&d2,2,0);
    x=n1; y=n2;  xy_rad(a8,x,y,&a3,&d3,2,0);
    x=n1; y=0;   xy_rad(a8,x,y,&a4,&d4,2,0);
    i=strlen(DIR)+1; f1[i+19]=0;
    fprintf(fp2,"%s%9.5lf%9.4lf%9.5lf%9.4lf%9.5lf%9.4lf%9.5lf%9.4lf",
          &f1[i],a1,d1,a2,d2,a3,d3,a4,d4);
    fprintf(fp2,"%8.2lf%5.2lf%7.4lf%3d",sky,seeing,weight,type);
    for(i=0;i<4;i++)fprintf(fp2,"%7.4f",ww[i]); fprintf(fp2,"\n");

    goto l10;
l20:
    fclose(fp1); 
  }
  fclose(fp2);
  printf("\n---> pos_g.dat\n");
}

#define bok 48.
xy_rad(a8,x,y,ra,de,type,k)
double *a8,x,y,*ra,*de;  int type,k;
{
  double xi,xn,tmp,tmp1;
  double x1,y1,r1,d1;
  double ac,dc;
  int i;
  ac=a8[6]; dc=a8[7];
  xi=a8[0]*x+a8[2]*y+a8[4];
  xn=a8[1]*x+a8[3]*y+a8[5];
  if(type==1){
    tmp=sqrt(xi*xi+xn*xn);
    if(tmp!=0.){
      tmp=tan(tmp)/tmp;
      xi*=tmp;  xn*=tmp;
    }
  }
  if(type==2){
    tmp=1.+bok*(xi*xi+xn*xn);

    for(i=0;i<4;i++){
      x1=xi/tmp; y1=xn/tmp;
      tmp=tan(dc);  tmp1=1.-y1*tmp;
      r1=atan(x1/cos(dc)/tmp1);
      d1=atan((y1+tmp)*cos(r1)/tmp1);
      r1+=ac;
      tmp=atan(tan(d1)/cos(r1-ac));
      x1=cos(tmp)*tan(r1-ac)/cos(tmp-dc);
      y1=tan(tmp-dc);
      tmp=1.+bok*(x1*x1+y1*y1);
    }
    xi/=tmp; xn/=tmp;
  }
  tmp=tan(dc);  tmp1=1.-xn*tmp;
  *ra=atan(xi/cos(dc)/tmp1);
  *de=atan((xn+tmp)*cos(*ra)/tmp1);
  *ra+=ac;
  tmp=(*de)-dc;
  if(tmp<0.)tmp=-tmp;
  if(tmp>pi2){  *de=-(*de);  *ra+=pi; }
  if(*ra<0.)*ra+=(pi+pi);
  if(k==0){ *ra/=cx; *de/=cy; }
}

